# swaggeraem
Swagger AEM is an OpenAPI specification for Adobe Experience Manager (AEM) API

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 3.5.0-pre.0
- Package version: 1.0.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen
For more information, please visit [http://shinesolutions.com](http://shinesolutions.com)

## Requirements.

Python >= 3.6

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/shinesolutions/swagger-aem.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/shinesolutions/swagger-aem.git`)

Then import the package:
```python
import swaggeraem
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import swaggeraem
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import time
import swaggeraem
from pprint import pprint
from swaggeraem.api import console_api
from swaggeraem.model.saml_configuration_info import SamlConfigurationInfo
# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = swaggeraem.Configuration(
    host = "http://localhost"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure HTTP basic authorization: aemAuth
configuration = swaggeraem.Configuration(
    username = 'YOUR_USERNAME',
    password = 'YOUR_PASSWORD'
)


# Enter a context with an instance of the API client
with swaggeraem.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = console_api.ConsoleApi(api_client)
    
    try:
        api_response = api_instance.get_aem_product_info()
        pprint(api_response)
    except swaggeraem.ApiException as e:
        print("Exception when calling ConsoleApi->get_aem_product_info: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ConsoleApi* | [**get_aem_product_info**](docs/ConsoleApi.md#get_aem_product_info) | **GET** /system/console/status-productinfo.json | 
*ConsoleApi* | [**get_config_mgr**](docs/ConsoleApi.md#get_config_mgr) | **GET** /system/console/configMgr | 
*ConsoleApi* | [**post_bundle**](docs/ConsoleApi.md#post_bundle) | **POST** /system/console/bundles/{name} | 
*ConsoleApi* | [**post_jmx_repository**](docs/ConsoleApi.md#post_jmx_repository) | **POST** /system/console/jmx/com.adobe.granite:type&#x3D;Repository/op/{action} | 
*ConsoleApi* | [**post_saml_configuration**](docs/ConsoleApi.md#post_saml_configuration) | **POST** /system/console/configMgr/com.adobe.granite.auth.saml.SamlAuthenticationHandler | 
*CqApi* | [**get_login_page**](docs/CqApi.md#get_login_page) | **GET** /libs/granite/core/content/login.html | 
*CqApi* | [**post_cq_actions**](docs/CqApi.md#post_cq_actions) | **POST** /.cqactions.html | 
*CrxApi* | [**get_crxde_status**](docs/CrxApi.md#get_crxde_status) | **GET** /crx/server/crx.default/jcr:root/.1.json | 
*CrxApi* | [**get_install_status**](docs/CrxApi.md#get_install_status) | **GET** /crx/packmgr/installstatus.jsp | 
*CrxApi* | [**get_package_manager_servlet**](docs/CrxApi.md#get_package_manager_servlet) | **GET** /crx/packmgr/service/script.html | 
*CrxApi* | [**post_package_service**](docs/CrxApi.md#post_package_service) | **POST** /crx/packmgr/service.jsp | 
*CrxApi* | [**post_package_service_json**](docs/CrxApi.md#post_package_service_json) | **POST** /crx/packmgr/service/.json/{path} | 
*CrxApi* | [**post_package_update**](docs/CrxApi.md#post_package_update) | **POST** /crx/packmgr/update.jsp | 
*CrxApi* | [**post_set_password**](docs/CrxApi.md#post_set_password) | **POST** /crx/explorer/ui/setpassword.jsp | 
*CustomApi* | [**get_aem_health_check**](docs/CustomApi.md#get_aem_health_check) | **GET** /system/health | 
*CustomApi* | [**post_config_aem_health_check_servlet**](docs/CustomApi.md#post_config_aem_health_check_servlet) | **POST** /apps/system/config/com.shinesolutions.healthcheck.hc.impl.ActiveBundleHealthCheck | 
*CustomApi* | [**post_config_aem_password_reset**](docs/CustomApi.md#post_config_aem_password_reset) | **POST** /apps/system/config/com.shinesolutions.aem.passwordreset.Activator | 
*GraniteApi* | [**ssl_setup**](docs/GraniteApi.md#ssl_setup) | **POST** /libs/granite/security/post/sslSetup.html | 
*SlingApi* | [**delete_agent**](docs/SlingApi.md#delete_agent) | **DELETE** /etc/replication/agents.{runmode}/{name} | 
*SlingApi* | [**delete_node**](docs/SlingApi.md#delete_node) | **DELETE** /{path}/{name} | 
*SlingApi* | [**get_agent**](docs/SlingApi.md#get_agent) | **GET** /etc/replication/agents.{runmode}/{name} | 
*SlingApi* | [**get_agents**](docs/SlingApi.md#get_agents) | **GET** /etc/replication/agents.{runmode}.-1.json | 
*SlingApi* | [**get_authorizable_keystore**](docs/SlingApi.md#get_authorizable_keystore) | **GET** /{intermediatePath}/{authorizableId}.ks.json | 
*SlingApi* | [**get_keystore**](docs/SlingApi.md#get_keystore) | **GET** /{intermediatePath}/{authorizableId}/keystore/store.p12 | 
*SlingApi* | [**get_node**](docs/SlingApi.md#get_node) | **GET** /{path}/{name} | 
*SlingApi* | [**get_package**](docs/SlingApi.md#get_package) | **GET** /etc/packages/{group}/{name}-{version}.zip | 
*SlingApi* | [**get_package_filter**](docs/SlingApi.md#get_package_filter) | **GET** /etc/packages/{group}/{name}-{version}.zip/jcr:content/vlt:definition/filter.tidy.2.json | 
*SlingApi* | [**get_query**](docs/SlingApi.md#get_query) | **GET** /bin/querybuilder.json | 
*SlingApi* | [**get_truststore**](docs/SlingApi.md#get_truststore) | **GET** /etc/truststore/truststore.p12 | 
*SlingApi* | [**get_truststore_info**](docs/SlingApi.md#get_truststore_info) | **GET** /libs/granite/security/truststore.json | 
*SlingApi* | [**post_agent**](docs/SlingApi.md#post_agent) | **POST** /etc/replication/agents.{runmode}/{name} | 
*SlingApi* | [**post_authorizable_keystore**](docs/SlingApi.md#post_authorizable_keystore) | **POST** /{intermediatePath}/{authorizableId}.ks.html | 
*SlingApi* | [**post_authorizables**](docs/SlingApi.md#post_authorizables) | **POST** /libs/granite/security/post/authorizables | 
*SlingApi* | [**post_config_adobe_granite_saml_authentication_handler**](docs/SlingApi.md#post_config_adobe_granite_saml_authentication_handler) | **POST** /apps/system/config/com.adobe.granite.auth.saml.SamlAuthenticationHandler.config | 
*SlingApi* | [**post_config_apache_felix_jetty_based_http_service**](docs/SlingApi.md#post_config_apache_felix_jetty_based_http_service) | **POST** /apps/system/config/org.apache.felix.http | 
*SlingApi* | [**post_config_apache_http_components_proxy_configuration**](docs/SlingApi.md#post_config_apache_http_components_proxy_configuration) | **POST** /apps/system/config/org.apache.http.proxyconfigurator.config | 
*SlingApi* | [**post_config_apache_sling_dav_ex_servlet**](docs/SlingApi.md#post_config_apache_sling_dav_ex_servlet) | **POST** /apps/system/config/org.apache.sling.jcr.davex.impl.servlets.SlingDavExServlet | 
*SlingApi* | [**post_config_apache_sling_get_servlet**](docs/SlingApi.md#post_config_apache_sling_get_servlet) | **POST** /apps/system/config/org.apache.sling.servlets.get.DefaultGetServlet | 
*SlingApi* | [**post_config_apache_sling_referrer_filter**](docs/SlingApi.md#post_config_apache_sling_referrer_filter) | **POST** /apps/system/config/org.apache.sling.security.impl.ReferrerFilter | 
*SlingApi* | [**post_config_property**](docs/SlingApi.md#post_config_property) | **POST** /apps/system/config/{configNodeName} | 
*SlingApi* | [**post_node**](docs/SlingApi.md#post_node) | **POST** /{path}/{name} | 
*SlingApi* | [**post_node_rw**](docs/SlingApi.md#post_node_rw) | **POST** /{path}/{name}.rw.html | 
*SlingApi* | [**post_path**](docs/SlingApi.md#post_path) | **POST** /{path}/ | 
*SlingApi* | [**post_query**](docs/SlingApi.md#post_query) | **POST** /bin/querybuilder.json | 
*SlingApi* | [**post_tree_activation**](docs/SlingApi.md#post_tree_activation) | **POST** /etc/replication/treeactivation.html | 
*SlingApi* | [**post_truststore**](docs/SlingApi.md#post_truststore) | **POST** /libs/granite/security/post/truststore | 
*SlingApi* | [**post_truststore_pkcs12**](docs/SlingApi.md#post_truststore_pkcs12) | **POST** /etc/truststore | 


## Documentation For Models

 - [InstallStatus](docs/InstallStatus.md)
 - [InstallStatusStatus](docs/InstallStatusStatus.md)
 - [KeystoreChainItems](docs/KeystoreChainItems.md)
 - [KeystoreInfo](docs/KeystoreInfo.md)
 - [KeystoreItems](docs/KeystoreItems.md)
 - [SamlConfigurationInfo](docs/SamlConfigurationInfo.md)
 - [SamlConfigurationProperties](docs/SamlConfigurationProperties.md)
 - [SamlConfigurationPropertyItemsArray](docs/SamlConfigurationPropertyItemsArray.md)
 - [SamlConfigurationPropertyItemsBoolean](docs/SamlConfigurationPropertyItemsBoolean.md)
 - [SamlConfigurationPropertyItemsLong](docs/SamlConfigurationPropertyItemsLong.md)
 - [SamlConfigurationPropertyItemsString](docs/SamlConfigurationPropertyItemsString.md)
 - [TruststoreInfo](docs/TruststoreInfo.md)
 - [TruststoreItems](docs/TruststoreItems.md)


## Documentation For Authorization


## aemAuth

- **Type**: HTTP basic authentication


## Author

opensource@shinesolutions.com


## Notes for Large OpenAPI documents
If the OpenAPI document is large, imports in swaggeraem.apis and swaggeraem.models may fail with a
RecursionError indicating the maximum recursion limit has been exceeded. In that case, there are a couple of solutions:

Solution 1:
Use specific imports for apis and models like:
- `from swaggeraem.api.default_api import DefaultApi`
- `from swaggeraem.model.pet import Pet`

Solution 1:
Before importing the package, adjust the maximum recursion limit as shown below:
```
import sys
sys.setrecursionlimit(1500)
import swaggeraem
from swaggeraem.apis import *
from swaggeraem.models import *
```

